/*
 * CopyrightiCj NEC Corporation, NEC CustomTechnica, Ltd. 2003
 * 
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifdef	_DEBUG

#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "common.h"
#include "myerror.h"
#include "debug.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

void PrintFormat (unsigned char *buf)
{
	FIXED_FORMAT *p = (FIXED_FORMAT *)buf;
	static char *name[] = {	"Manager",
							"UI",
							"COM",
							"TV",
							"EPG",
							"FILE",
							"REC",
							"LCD",
							"SETUP",
							"RECOVERY",
							"UPDATE",
							"APM" };

	TraceDisp3("Packet Information:\n");
	TraceDisp3("To       : id=%s(%x) addr=%04d.%04d.%04d.%04d",
							name[p->to.id], p->to.id,
							p->to.addr[0], p->to.addr[1], p->to.addr[2], p->to.addr[3] );
//	TraceDisp3("           resv = %02x %02x %02x %02x\n",
//							p->to.ex[0], p->to.ex[1], p->to.ex[2], p->to.ex[3] );
	TraceDisp3("From     : id=%s(%x) addr=%04d.%04d.%04d.%04d",
							name[p->from.id], p->from.id,
							p->from.addr[0], p->from.addr[1], p->from.addr[2], p->from.addr[3] );
//	TraceDisp3("           resv = %02x %02x %02x %02x\n",
//							p->from.ex[0], p->from.ex[1], p->from.ex[2], p->from.ex[3] );
	TraceDisp3("Command  : %02x", p->command);
	TraceDisp3("Status   : %02x", p->status);
	TraceDisp3("Datatype : %04x", p->datatype);
//	TraceDisp3("Reserve  : %02x %02x %02x %02x %02x %02x %02x %02x\n",
//							p->reserve[0], p->reserve[1], p->reserve[2], p->reserve[3], 
//							p->reserve[4], p->reserve[5], p->reserve[6], p->reserve[7] );
	TraceDisp3("DataLen  : %d", p->datalength);

	if (p->datalength > 0) {
		char ext[100];
		char dmy[10];
		strcpy(ext, "Extend   : ");
		for (int i=0; i<p->datalength; i++) {
			sprintf(dmy, "%02x ", (unsigned char)buf[FIXED_AREA_SIZE + i]);
			strcat(ext, dmy);
#if	0
			if (i%8 == 7) {
				printf("\n           ");
			}
#else
			if (i%8 == 7) break;
#endif
		}
		TraceDisp3("%s\n", ext);
	}
}

void PrintFormat2 (FIXED_FORMAT buf1, unsigned char *buf2)
{
	unsigned char *p = (unsigned char *) malloc (FIXED_AREA_SIZE + buf1.datalength);
	memcpy(p, &buf1, FIXED_AREA_SIZE);
	memcpy(p+FIXED_AREA_SIZE, buf2, buf1.datalength);
	PrintFormat(p);
	free(p);
}

#ifdef __cplusplus
}
#endif	/* __cplusplus */

#endif	/* _DEBUG */

