/*
 * CopyrightC NEC Corporation, NEC CustomTechnica, Ltd. 2003
 * 
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef __COMMON_H__
#define __COMMON_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


// Windows compatible
#ifndef FALSE
#define FALSE				0
#endif

#ifndef TRUE
#define TRUE				1
#endif

typedef unsigned short USHORT;
typedef unsigned char UCHAR;

typedef unsigned long		DWORD;
typedef int 				BOOL;
typedef unsigned char		BYTE;
typedef unsigned short		WORD;
typedef float				FLOAT;
typedef int 				INT;
typedef unsigned int		UINT;
typedef char				_TCHAR;
typedef long				LONG;
typedef unsigned long		ULONG;
typedef long long			LONGLONG;
typedef unsigned long long	ULONGLONG;

typedef DWORD	COLORREF;

typedef union _LARGE_INTEGER {
	struct {
		DWORD LowPart;
		LONG HighPart;
	} u;
	LONGLONG QuadPart;
} LARGE_INTEGER;

typedef union _ULARGE_INTEGER {
	 struct {
	DWORD LowPart;
	DWORD HighPart;
	} u;
	ULONGLONG QuadPart;
} ULARGE_INTEGER;

typedef LARGE_INTEGER *PLARGE_INTEGER;
typedef ULARGE_INTEGER *PULARGE_INTEGER;

#define MAKEWORD(a, b)		((WORD)(((BYTE)(a)) | ((WORD)((BYTE)(b))) << 8))
#define MAKELONG(a, b)		((LONG)(((WORD)(a)) | ((DWORD)((WORD)(b))) << 16))
#define LOWORD(l)			((WORD)(l))
#define HIWORD(l)			((WORD)(((DWORD)(l) >> 16) & 0xFFFF))
#define LOBYTE(w)			((BYTE)(w))
#define HIBYTE(w)			((BYTE)(((WORD)(w) >> 8) & 0xFF))

#define MAX_PATH 260
#define _MAX_PATH	260 /* max. length of full pathname */
#define _MAX_DRIVE	3	/* max. length of drive component */
#define _MAX_DIR	256 /* max. length of path component */
#define _MAX_FNAME	256 /* max. length of file name component */
#define _MAX_EXT	256 /* max. length of extension component */

#define HWND  void *

#pragma pack(1)
typedef struct _SYSTEMTIME {
	WORD wYear;
	WORD wMonth;		//  january=1 februry=2 ...
	WORD wDayOfWeek;	//  Sunday=0 Monday=1 ...
	WORD wDay;			// 
	WORD wHour;			// 
	WORD wMinute;		// ʬ
	WORD wSecond;		// 
	WORD wMilliseconds;	// ߥñ MCǤ̵
}  SYSTEMTIME;
#pragma pack()

// Windows compatible


#define		ID_AREA_SIZE			1	// ⥸塼IDΰ襵
#define		ADDRESS_AREA_SIZE		4	// IPɥ쥹ΰ襵
#define		PORT_AREA_SIZE			2	// ݡֹΰ襵
#define		EX_AREA_SIZE			2	// ĥɥ쥹

#pragma pack(1)
typedef struct
{
	unsigned	char	id;							// ⥸塼ID
	unsigned	char	addr[ADDRESS_AREA_SIZE];	// IPɥ쥹
	unsigned	short	port;						// ݡֹ
	unsigned	char	ex[EX_AREA_SIZE];			// ĥΰ
}  ADDR;
#pragma pack()

#define		COMMAND_AREA_SIZE		1	// ޥΰ襵
#define		STATUS_AREA_SIZE		1	// ơΰ襵
#define		DATATYPE_AREA_SIZE		2	// ḁ̇̄
#define		RESERVED_AREA_SIZE		8	// ͽ
#define		DATALENGTH_AREA_SIZE	2	// ǡĹ

#pragma pack(1)
typedef struct
{
	ADDR		to;						// 襢ɥ쥹
	ADDR		from;					// ɥ쥹
	unsigned	char	command;		// ޥ(0x00-0xff)
	unsigned	char	status;			// ơ
	unsigned	short	datatype;		// ǡ
	unsigned	char	reserve[RESERVED_AREA_SIZE];		// ͽ
	unsigned	short	datalength;		// ǡĹ
} FIXED_FORMAT;
#pragma pack()

#define		MAX_PACKET_SIZE		32768	// 1ѥåȺǡ
#define		FIXED_AREA_SIZE		sizeof(FIXED_FORMAT)	// ǡ
#define		MAX_DATA_SIZE		(MAX_PACKET_SIZE - FIXED_AREA_SIZE)
														// ǡ

// Module ID
#define		MID_MGR			0x00	// Manager
#define		MID_UI			0x01	// UI
#define		MID_COM			0x02	// ̿⥸塼
#define		MID_TV			0x03	// ԣֻİϿ⥸塼
#define		MID_EPG			0x04	// ţУǴ⥸塼
#define		MID_FILE		0x05	// ե⥸塼
#define		MID_RSV			0x06	// Ͽͽ⥸塼
#define		MID_LCD			0x07	// ̣ãĴ⥸塼
#define		MID_SETUP		0x08	// ⥸塼
#define		MID_RECOVERY	0x09	// ȣģĥꥫХ⥸塼
#define		MID_UPDATE		0x0a	// BIOS/Systemåץǡ
#define		MID_APM			0x0b	// Уͥ⥸塼
#define		MID_BROADPASS	0x0c	// BroadPass ѥ⥸塼
#define		MID_IMODE		0x0d	// i-modeϿͽѥ⥸塼CGIХѥ

#define		MID_DMY			0xff	// for Debug
// 0x0b-0xfe Reserved


#define		INITIALIZE_VALUE	0x00	// ̤ΰ

// Command
// ξƬӥåȤΩƤ
#define		RESPONSE_FLG	0x80	// ե饰

#define		CMD_POWERON		0x00	// ŸON׵
#define		CMD_POWEROFF	0x01	// ŸOFF׵
#define		CMD_REBOOT		0x02	// ֡׵
#define		CMD_START		0x03	// ⥸塼볫׵
#define		CMD_SHUT		0x04	// ⥸塼뽪λ׵
#define		CMD_START2		0x05	// ⥸塼볫׵
#define		NOTICE_STOP_COM	0x06	// ̿׵
#define		CMD_ERROR		0x0f	// 顼
// 0x07-0x0e Undfined

// Status
#define		STS_SUCCESS				0x00	// ơ
#define		STS_SELECT_TIMEOVER		0x01	// 顼(ॢ)
#define		STS_SELECT_ERROR		0x02	// 顼(selectǥ顼)
#define		STS_READ_ERROR			0x03	// 顼(readǥ顼)
#define		STS_UNKNOWN_COMMAND		0x04	// 顼(̤Υޥɼ)
#define		STS_NOT_READY			0x05	// 顼(̤ǤΥǡ)
#define		STS_DISK_ERROR			0x06	// ǥ顼
#define		STS_MEMORY_ERROR		0x07	// ꥨ顼
#define		STS_FORMAT_ERROR		0x08	// եޥåȥ顼
#define		STS_REJECT_REQUEST		0x09	// ݱơ

// Reason for STS_REJECT_REQUEST
#define		REASON_RECORDING		0x00	// ϿΤ
#define		REASON_RESERVE_NEAR		0x01	// ͽϿ褬ᤤ
#define		REASON_CLIENT_CONNECT	0x02	// ѥ³Τ

// Datatype
// ѥåȤ³ƬӥåȤΩƤ
#define		PACKET_FLG			0x80	// ѥåȷ³ե饰

// select
#define		SELECT_TIMEOVER		0
#define		SELECT_ERROR		-1

// Logfile Define
#define     MAX_LOG_LINE    512     // ϹԿ
#define     MAX_LOG_COLUMN  80      // Ϸ

// Common Define Path
#define MC_BASE_PATH			"/opt/MC"
#define MC_ENVIRONMENT_PATH		"/opt/MC/etc"
#define MC_LOGFILE_PATH			"/opt/MC/tmp/log"
#define MC_TEMPORARY_PATH		"/opt/MC/tmp"
#define RECORDING_PATH			"/mnt/disk1/data/REC"
#define RECTEMP_PATH			"/mnt/disk1/data/RECTEMP"
#define TIMESHIFT_PATH			"/mnt/disk1/data/TIMESHIFT"
#define ADAMS_EPG_PATH			"/opt/MC/etc/ADAMS-EPG"

#define SVI_ROOT "/mnt/disk1/data/REC"
//#define EPG_ROOT "/mnt/disk1/data/EPG"


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __COMMON_H__ */
