/*
 * CopyrightiCj NEC Corporation, NEC CustomTechnica, Ltd. 2003
 * 
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef __MYERROR_H__
#define __MYERROR_H__

#include <stdarg.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include "common.h"



#define ENV_ERRORLOG_FILE_NAME "ENV_ERRORLOG_FILE_NAME"
#define DEFAULT_ERRORLOG_FILE_NAME "./logfile"

#define ENV_ERRORLOG_LINE_COUNT "ENV_ERRORLOG_LINE_COUNT"
#define DEFAULT_ERRORLOG_LINE_COUNT 128

#define NO_ERROR 0

//#define _DEBUG
//#define _DEBUG1

#ifdef _DEBUG

void TraceDisp_main(const char* strtrace1);
void TraceDisp(const char* szMsg, ...);

#ifdef _DEBUG1
void TraceDisp1(const char* szMsg, ...);
#else
#define TraceDisp1(a...)
#endif

#ifdef _DEBUG2
void TraceDisp2(const char* szMsg, ...);
#else
#define TraceDisp2(a...)
#endif

#ifdef _DEBUG3
void TraceDisp3(const char* szMsg, ...);
#else
#define TraceDisp3(a...)
#endif

#ifdef _DEBUG4
void TraceDisp4(const char* szMsg, ...);
#else
#define TraceDisp4(a...)
#endif

#ifdef _DEBUG5
void TraceDisp5(const char* szMsg, ...);
#else
#define TraceDisp5(a...)
#endif

#ifdef _DEBUG6
void TraceDisp6(const char* szMsg, ...);
#else
#define TraceDisp6(a...)
#endif

#else
#define TraceDisp_main
#define TraceDisp(a...)


#define TraceDisp1(a...)
#define TraceDisp2(a...)
#define TraceDisp3(a...)
#define TraceDisp4(a...)
#define TraceDisp5(a...)
#define TraceDisp6(a...)
#endif

#if defined(__GNU_LIBRARY__) && !defined(_SEM_SEMUN_UNDEFINED)
/* p semun ̒` <sys/sem.h> Ɋ܂܂Ă */
#else
/* X/OPEN ɏ]ȂΎgňȉ̂悤ɒ`Ȃ΂ȂȂ */
union semun {
	 int val;					 /* value for SETVAL */
	 struct semid_ds *buf;		 /* buffer for IPC_STAT, IPC_SET */
	 unsigned short int *array;  /* array for GETALL, SETALL */
	 struct seminfo *__buf; 	 /* buffer for IPC_INFO */
};
#endif


class CSemaphore
{
public:
	CSemaphore();
	~CSemaphore();

	int Initialize(int nModuleId);
	int SetSemValue();
	int DelSemValue();
	int Semaphore_p();
	int Semaphore_v();
	int Lock();
	int Unlock();

protected:
	int   m_nSemId;		// Z}tHID
	key_t m_keyid;		// KEYID
	int   m_nModuleId;

};



class CErrorCode
{
public:
	CErrorCode();
	~CErrorCode();

protected:
	UINT   m_nErrorCode;			// G[R[h
	char   m_szErrorFile[MAX_PATH];	// G[̔\[Xt@C
	int    m_nLineNo;			// G[̔sԍ
	int    m_nLastError;			// G[̔sԍ

	char m_szLogFileName[MAX_PATH];	// ۑ郍Ot@C
	char m_szErrorLogFile[MAX_PATH];	// G[Ot@C
	int  m_nErrorLogLine;			// G[ލsԍ
	int  m_nErrorLogLineMax;		// s
	int  m_nErrorLogColumsMax;		// s
	int  m_nModuleId;			// W[ID

public:
	int Initialize(const char* szLogName, int nLine, int nColums, int nModuleId);
	int GetErrorCode() const
		{ return m_nErrorCode; }
	int SetErrorCode(int errcode, const char* szErrorFile, int nLineNo, int nLastError);
	BOOL IsError() const
		{ return (m_nErrorCode != 0); }
	int OutputLog(char* szMsg, ...);

protected:
	int OutputValist(char* szMsg, ...);
	int ErrorLogOut(char* szMsg, va_list argList);
//	CRITICAL_SECTION m_csAcressFileDB;	// NeBJZNVǉ 2002/01/10 t.masuzawa
	CSemaphore m_Semaphore;
};

#endif
